unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Unit2;

type
  TAnswerForm = class(TForm)
    GreetingTitle: TLabel;
    GreetingBevel: TBevel;
    GreetingFileLabel: TLabel;
    GreetingFileEdit: TEdit;
    GreetingPlayButton: TButton;
    GreetingStopButton: TButton;
    GreetingRecordButton: TButton;
    GreetingBrowseButton: TButton;
    AnswerTitle: TLabel;
    AnswerBevel: TBevel;
    AnswerFileLabel: TLabel;
    AnswerFileEdit: TEdit;
    AnswerPlayButton: TButton;
    AnswerStopButton: TButton;
    AnswerBrowseButton: TButton;
    WaitTitle: TLabel;
    WaitBevel: TBevel;
    WaitButton: TButton;
    WaitCancelButton: TButton;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure GreetingBrowseButtonClick(Sender: TObject);
    procedure GreetingPlayButtonClick(Sender: TObject);
    procedure GreetingStopButtonClick(Sender: TObject);
    procedure GreetingRecordButtonClick(Sender: TObject);
    procedure AnswerBrowseButtonClick(Sender: TObject);
    procedure AnswerPlayButtonClick(Sender: TObject);
    procedure AnswerStopButtonClick(Sender: TObject);
    procedure WaitButtonClick(Sender: TObject);
    procedure WaitCancelButtonClick(Sender: TObject);
  private
    procedure WMModemNotify(var Message: TMessage); message WM_MODEMNOTIFY;
  public
    { Public declarations }
  end;

var
  AnswerForm: TAnswerForm;

implementation

{$R *.DFM}

procedure TAnswerForm.WMModemNotify(var Message: TMessage);
const
  Cursors: array[Boolean] of TCursor = (crDefault, crAppStart);
begin
  with Message do
  begin
    if (LParam = Longint(GreetingPlayButton)) or (LParam = Longint(GreetingRecordButton)) then
    begin
      GreetingPlayButton.Enabled := WParam = MS_IDLE;
      GreetingStopButton.Enabled := WParam in [MS_PLAYING, MS_RECORDING];
      GreetingRecordButton.Enabled := WParam = MS_IDLE;
    end;
    if LParam = Longint(AnswerPlayButton) then
    begin
      AnswerPlayButton.Enabled := WParam = MS_IDLE;
      AnswerStopButton.Enabled := WParam in [MS_PLAYING, MS_RECORDING];
    end;
    if LParam = Longint(WaitButton) then
    begin
      WaitButton.Enabled := WParam = MS_IDLE;
      WaitCancelButton.Enabled := WParam in [MS_ANSWERING];
    end;
    Screen.Cursor := Cursors[WParam in [MS_STARTING, MS_STOPPING]];
  end;
end;

procedure TAnswerForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  ModemModule.Stop(True);
end;

procedure TAnswerForm.GreetingBrowseButtonClick(Sender: TObject);
begin
  with OpenDialog do
  begin
    FileName := GreetingFileEdit.Text;
    if Execute then GreetingFileEdit.Text := FileName;
  end;
end;

procedure TAnswerForm.GreetingPlayButtonClick(Sender: TObject);
begin
  ModemModule.PlayFile(Sender, GreetingFileEdit.Text);
end;

procedure TAnswerForm.GreetingStopButtonClick(Sender: TObject);
begin
  ModemModule.Stop(False);
end;

procedure TAnswerForm.GreetingRecordButtonClick(Sender: TObject);
begin
  ModemModule.RecordFile(Sender, GreetingFileEdit.Text);
end;

procedure TAnswerForm.AnswerBrowseButtonClick(Sender: TObject);
begin
  with SaveDialog do
  begin
    FileName := AnswerFileEdit.Text;
    if Execute then AnswerFileEdit.Text := FileName;
  end;
end;

procedure TAnswerForm.AnswerPlayButtonClick(Sender: TObject);
begin
  ModemModule.PlayFile(Sender, AnswerFileEdit.Text);
end;

procedure TAnswerForm.AnswerStopButtonClick(Sender: TObject);
begin
  ModemModule.Stop(False);
end;

procedure TAnswerForm.WaitButtonClick(Sender: TObject);
begin
  ModemModule.WaitRing(Sender, GreetingFileEdit.Text, AnswerFileEdit.Text);
end;

procedure TAnswerForm.WaitCancelButtonClick(Sender: TObject);
begin
  ModemModule.Stop(False);
end;

end.
